//+------------------------------------------------------------------+
//|                                                      .mq4 |
//|  - .      :)              |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011,  .."
#property link      "alextar@bk.ru"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Green  // 
#property indicator_color2 Green  // ()
#property indicator_color3 Red    // 
#property indicator_color4 Red    // ()
#property indicator_color5 Yellow // 
#property indicator_color6 Yellow // ()
//--- input parameters
extern int Width=20,       //    
           TotalBars=60;   //    
extern double Speed=5;     //    ( - )
//--- buffers
double UH[], UL[], DH[], DL[], FH[], FL[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,UH);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UL);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,DH);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,DL);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,FH);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,FL);
   
   if( TotalBars<1 ) TotalBars=Bars;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int Bar1=TotalBars-1, Bar2, i;
   double Price1, Price2, min, max;
//----
   while( Bar1>=0 )
     {
      Price1=0.5*(High[Bar1]+Low[Bar1]);
      Bar2=Bar1;
      while( Bar2>=0 )
        {
         Price2=0.5*(High[Bar2]+Low[Bar2]);
         if( High[Bar2]>Price2+0.5*Width*Point || Low[Bar2]<Price2-0.5*Width*Point ) break;
         Bar2--;
        }
      if( Bar1>Bar2 && Bar2>=0 )
         if( (Price2-Price1)/(Point*(Bar1-Bar2))-Speed>0.5*Point )
           {
            UH[Bar1]=Price1+0.5*Width*Point;
            UH[Bar2]=Price2+0.5*Width*Point;
            UL[Bar1]=Price1-0.5*Width*Point;
            UL[Bar2]=Price2-0.5*Width*Point;
           }
         else if( (Price1-Price2)/(Point*(Bar1-Bar2))-Speed>0.5*Point )
           {
            DH[Bar1]=Price1+0.5*Width*Point;
            DH[Bar2]=Price2+0.5*Width*Point;
            DL[Bar1]=Price1-0.5*Width*Point;
            DL[Bar2]=Price2-0.5*Width*Point;
           }
         else
           {
            min=9999999;
            max=0;
            i=Bar2;
            while( i<=Bar1 )
              {
               if( min>Low[i] ) min=Low[i];
               if( max<High[i] ) max=High[i];
               i++;
              }
            FH[Bar1]=max;
            FH[Bar2]=max;
            FL[Bar1]=min;
            FL[Bar2]=min;
           }
      Bar1--;
     }
   WindowRedraw();
//----
   return(0);
  }
//+------------------------------------------------------------------+